# To contribute improvements to CI/CD templates, please follow the Development guide at:
# https://docs.gitlab.com/ee/development/cicd/templates.html
# This specific template is located at:
# https://gitlab.com/gitlab-org/gitlab/-/blob/master/lib/gitlab/ci/templates/Docker.gitlab-ci.yml

# Build a Docker image with CI/CD and push to the GitLab registry.
# Docker-in-Docker documentation: https://docs.gitlab.com/ee/ci/docker/using_docker_build.html
#
# This template uses one generic job with conditional builds
# for the default branch and all other (MR) branches.

## define stages:
stages:
    - scan
    - build
    - test
    - deploy 
# Use the official docker image.
image: docker:latest
services:
    - docker:dind
before_script:
    - apk add --update curl && rm -rf /var/cache/apk/*
    - curl -sfL https://raw.githubusercontent.com/aquasecurity/trivy/master/contrib/install.sh | sh -s -- -b /usr/local/bin 
    - trivy --version
    - apk add --update npm
    - npm install
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" $CI_REGISTRY
security_scan: #scan image using tryvi
  stage: scan
  image: 
    name: aquasec/trivy:latest
    entrypoint: [""]
  services:
    - docker:dind
  # tags:
  #   - docker
  script:
    - trivy --no-progress --output scanning-report.txt  $CI_REGISTRY_IMAGE:latest
  artifacts:
    reports:
      container_scanning: scanning-report.txt
build: #job build
  stage: build
  script:
    - trivy image registry.gitlab.com/vti-cloud/cert-gen-v2:feature-4 
    - >
      if [[ "$CI_COMMIT_BRANCH" == "$CI_DEFAULT_BRANCH" ]]; then
        tag=""
        echo "Running on default branch '$CI_DEFAULT_BRANCH': tag = 'latest'"
      else
        tag=":$CI_COMMIT_REF_SLUG"
        echo $CI_COMMIT_REF_SLUG
        echo "Running on branch '$CI_COMMIT_BRANCH': tag = $tag"
      fi
    - docker pull $CI_REGISTRY_IMAGE:latest || true  
    - docker build --cache-from $CI_REGISTRY_IMAGE${tag} -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA -t "$CI_REGISTRY_IMAGE${tag}" --build-arg BUILDKIT_INLINE_CACHE=1 .
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push "$CI_REGISTRY_IMAGE${tag}"
  # only:
  #   - master
  rules:
    - if: $CI_COMMIT_BRANCH
      exists:
        - Dockerfile
# test: #job test
#   stage: test
#   script:
#     - npm run test

#deploy:
  #stage: deploy
  #before_script:
    #- apk add --update curl && rm -rf /var/cache/apk/*
    #- curl -LO "https://dl.k8s.io/release/$(curl -L -s https://dl.k8s.io/release/stable.txt)/bin/linux/amd64/kubectl"
    #- install -o root -g root -m 0755 kubectl /usr/local/bin/kubectl
    #- kubectl version --client
    #- apk add --update py3-pip && pip3 install awscli --upgrade
    #- aws configure set aws_access_key_id $AWS_ACCESS_KEY_ID
    #- aws configure set aws_secret_access_key $AWS_SECRET_ACCESS_KEY
    #- aws configure set region $AWS_DEFAULT_REGION
  #script:
    #- echo "Update file kubeconfig..."
    #- aws eks --region "$AWS_DEFAULT_REGION" update-kubeconfig --name "$CLUSTER_NAME"
    #- echo "Deploy EKS manifest..."
    #- kubectl apply -f deployment.yml
    #- kubectl apply -f service.yml

  

  
